#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

#include "expreval/expreval.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	void open();
    void close();
	static bool getModuleProperties (SEModuleProperties* properties);
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);

    int NeedStop(void);

private:
	float *inputu_buffer; // pointer to circular buffer of samples
	float *inputv_buffer;
    float *inputw_buffer;
    float *inputx_buffer;
    float *inputy_buffer;
    float *inputz_buffer;
	float *output1_buffer;
    float *output2_buffer;
    float *output3_buffer;
    char *input_expr;
    char *input_init;

    exprFuncList *funcs;
    exprValList *vars;
    exprValList *consts;
    exprObj *obj;
    exprObj *init;

    EXPRTYPE *e_u, *e_v, *e_w, *e_x, *e_y, *e_z;
    EXPRTYPE *e_o1, *e_o2, *e_o3;
    EXPRTYPE *e_t, *e_n, *e_r;

    int ready;
    int needstop;

    double curtime, deltatime;
    unsigned long cursamp;
    
};
#endif
